const Overview = imports.ui.main.overview;

let _originalSignal = [];

let _manager, _workspace;

function windowAdded()
{
    Overview.hide();
}

function windowRemoved()
{
    if (_workspace.list_windows().length == 0)
    {
        if (!Overview.visible)
            Overview.viewSelector.showApps();
    }
    else
        windowAdded();
}

function disconnectWindowSignals()
{
    if (_originalSignal['window-added'])
        _workspace.disconnect(_originalSignal['window-added']);

    if (_originalSignal['window-removed'])
        _workspace.disconnect(_originalSignal['window-removed']);
}

function workspaceSwitched()
{
    disconnectWindowSignals();

    _workspace = _manager.get_active_workspace();

    _originalSignal['window-added'] = _workspace.connect('window-added', windowAdded);
    _originalSignal['window-removed'] = _workspace.connect('window-removed', windowRemoved);

    windowRemoved();
}

function init()
{
    _manager = global.screen;
    if (_manager == null)
        _manager = global.workspace_manager;
}

function enable()
{
    _originalSignal['workspace-switched'] = _manager.connect('workspace-switched', workspaceSwitched);

    workspaceSwitched();
}

function disable()
{
    disconnectWindowSignals();

    _manager.disconnect(_originalSignal['workspace-switched']);
}
